------------------------
-- alles sauber machen
-----------------------
delete from w;

--------------------
-- k=3
-- Initialisierung
--------------------

insert into w (wid,it,sl,sw,pl,pw)
select wid, iter, avg(sl), avg(sw), avg(pl), avg(pw)
from (
  select floor(dbms_random.value(1,3+1)) as wid,
    0 as iter,
    sepallength as sl, sepalwidth as sw, petallength as pl, petalwidth as pw
    from iris
) a
group by a.wid, a.iter;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=0
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=0
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=0;


-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=0 and q_error=(select max(q_error) from w where it=0)
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=0;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=0
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=0
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=0;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 1 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=1-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=1-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=1;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=1 and
      q_error=(select max(q_error) from w where it=1 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=1;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=1;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 2 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=2-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=2-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=2
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=2
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=2;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=2 and
      q_error=(select max(q_error) from w where it=2 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=2;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=2
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=2
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=2;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 3 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=3-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=3-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=3
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=3
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=3;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=3 and
      q_error=(select max(q_error) from w where it=3 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=3;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=3
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=3
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=3;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 4 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=4-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=4-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=4
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=4
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=4;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=4 and
      q_error=(select max(q_error) from w where it=4 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=4;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=4
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=4
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=4;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 5 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=5-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=5-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=5
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=5
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=5;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=5 and
      q_error=(select max(q_error) from w where it=5 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=5;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=5
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=5
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=5;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 6 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=6-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=6-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=6
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=6
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=6;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=6 and
      q_error=(select max(q_error) from w where it=6 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=6;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=6
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=6
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=6;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 7 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=7-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=7-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=7
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=7
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=7;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=7 and
      q_error=(select max(q_error) from w where it=7 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=7;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=7
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=7
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=7;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 8 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=8-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=8-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=8
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=8
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=8;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=8 and
      q_error=(select max(q_error) from w where it=8 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=8;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=8
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=8
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=8;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 9 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=9-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=9-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=9
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=9
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=9;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=9 and
      q_error=(select max(q_error) from w where it=9 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=9;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=9
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=9
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=9;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 10 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=10-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=10-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=10
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=10
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=10;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=10 and
      q_error=(select max(q_error) from w where it=10 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=10;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=10
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=10
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=10;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 11 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=11-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=11-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=11
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=11
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=11;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=11 and
      q_error=(select max(q_error) from w where it=11 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=11;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=11
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=11
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=11;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 12 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=12-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=12-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=12
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=12
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=12;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=12 and
      q_error=(select max(q_error) from w where it=12 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=12;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=12
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=12
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=12;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 13 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=13-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=13-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=13
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=13
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=13;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=13 and
      q_error=(select max(q_error) from w where it=13 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=13;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=13
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=13
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=13;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 14 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=14-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=14-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=14
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=14
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=14;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=14 and
      q_error=(select max(q_error) from w where it=14 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=14;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=14
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=14
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=14;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 15 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=15-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=15-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=15
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=15
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=15;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=15 and
      q_error=(select max(q_error) from w where it=15 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=15;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=15
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=15
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=15;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 16 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=16-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=16-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=16
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=16
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=16;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=16 and
      q_error=(select max(q_error) from w where it=16 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=16;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=16
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=16
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=16;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 17 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=17-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=17-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=17
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=17
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=17;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=17 and
      q_error=(select max(q_error) from w where it=17 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=17;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=17
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=17
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=17;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 18 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=18-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=18-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=18
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=18
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=18;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=18 and
      q_error=(select max(q_error) from w where it=18 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=18;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=18
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=18
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=18;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 19 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=19-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=19-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=19
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=19
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=19;

-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=19 and
      q_error=(select max(q_error) from w where it=19 )
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=19;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=19
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=19
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=19;
----------------
--- Schritt 2
----------------
insert into w (wid, it, sl, sw, pl, pw)
select wid, 20 as it, sl, sw, pl, pw
from (
select d.wid,
avg(sepallength) as sl, avg(sepalwidth) as sw, avg(petallength) as pl, avg(petalwidth) as pw
from ( select b.pid, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
             from iris i,w
             where it=20-1
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                sqrt((i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw)) as dist
            from iris i,w
           where it=20-1
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid
     )d, iris i
where d.pid = i.pid
group by d.wid
);

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=20
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=20
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=20;
