------------------------
-- alles sauber machen
-----------------------
delete from w;

--------------------
-- k=YYY
-- Initialisierung
--------------------

insert into w (wid,it,sl,sw,pl,pw)
select wid, iter, avg(sl), avg(sw), avg(pl), avg(pw)
from (
  select floor(dbms_random.value(1,YYY+1)) as wid,
    0 as iter,
    sepallength as sl, sepalwidth as sw, petallength as pl, petalwidth as pw
    from iris
) a
group by a.wid, a.iter;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=0
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=0
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=0;


-------------------------------
-- Verschiebe Repraesentanten
-------------------------------
update w w1
set (sl,sw,pl,pw)=
(
select
sl + ((select (max(i.sepallength)-min(i.sepallength))/50 from iris i) * dbms_random.value(-1,1)),
sw + ((select (max(i.sepalwidth)-min(i.sepalwidth))/50 from iris i)* dbms_random.value(-1,1)),
pl + ((select (max(i.petallength)-min(i.petallength))/50 from iris i)* dbms_random.value(-1,1)),
pw + ((select (max(i.petalwidth)-min(i.petalwidth))/50 from iris i)* dbms_random.value(-1,1))
from w
where it=0 and q_error=(select max(q_error) from w where it=0)
)
where (w1.anzahl<3 or w1.anzahl is null) and w1.it=0;

----------------------------------------------------------------
--- lokaler Quantisierungsfehler und Anzahl zugeordneter Punkte
----------------------------------------------------------------

update w w1
set (anzahl, q_error)=
( select
count(*) as anzahl, sum(dist) as lokal_q_error
from ( select b.pid, c.dist as dist, min(c.wid) as wid
       from (
           select pid, min(dist) as min_dist
           from (
             select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
             from iris i,w
             where it=0
             ) a
           group by a.pid
         ) b,
         ( select pid, wid,
                     (i.sepallength-w.sl)*(i.sepallength-w.sl)+
                     (i.sepalwidth-w.sw)*(i.sepalwidth-w.sw)+
                     (i.petallength-w.pl)*(i.petallength-w.pl)+
                     (i.petalwidth-w.pw)*(i.petalwidth-w.pw) as dist
            from iris i,w
           where it=0
         ) c
       where b.pid=c.pid and b.min_dist=c.dist
       group by b.pid, c.dist
     )d, iris i
where d.pid = i.pid and w1.wid=d.wid
group by d.wid
)
where
w1.it=0;
